import { type IFilledOptions } from '@idlebox/tsconfig-loader';
import { type IRigConfig } from '@rushstack/rig-package';
import type TApiExtractor from '@microsoft/api-extractor';
import type { HeftConfiguration } from '@rushstack/heft';
import type { ITypeScriptConfigurationJson } from '@rushstack/heft-typescript-plugin';
export declare function loadHeftConfig(heftConfiguration: HeftConfiguration): RushStackConfig;
export type IWarning = (message: string) => void;
export declare class RushStackConfig {
    private readonly warning;
    private typescriptConfig?;
    private tsconfigConfig?;
    private apiExtractorConfig?;
    private readonly rigConfig;
    private readonly localRequire;
    private readonly rigRequire?;
    private readonly localRequirePath;
    private readonly rigRequirePath?;
    readonly projectFolder: string;
    /**
     *
     * @param projectFolder absolute path of directory where the package.json is in
     */
    constructor(projectFolder: string, rigConfig?: IRigConfig, warning?: IWarning);
    require(packageName: string): any;
    resolve(packageName: string): string;
    apiExtractor(): TApiExtractor.IConfigFile | undefined;
    typescriptSearchSrcFolder: boolean;
    private defaultTypeScript;
    private projectRootResolver;
    typescript(): ITypeScriptConfigurationJson;
    tsconfigPath(): string | undefined;
    tsconfig(alterPath?: string): IFilledOptions;
}
//# sourceMappingURL=api.d.ts.map